Subject: [bug#59845] [PATCH 0/4] Add PMB (Integrated Library System)

From: Ludovic Courtès <[email-masked]>
Date: Sun, 25 Dec 2022 18:26:25 +0100

Hi,

"yarl baudig" <[email-masked]> skribis:

>> >
>> > Now, I see one solution to avoid the copy (and the chown), apart from the 
>> very first activation. That's keeping even more state into http-directory : 
>> for example a file ".version" with the hash of the pmb package used inside. 
>> That way we know if there's really an upgrade. What do you think?
>> 
>> It sounds like it’s going a bit far in terms of complexity.
>> 
>> Why do we need to copy these files every time?  Do they actually have to
>> be writable?  If not, whatever this copying step is doing could be done
>> in a ‘computed-file’.
>> 
>> Does that make sense?
>> 
>
> Hmm no, not really. Yes it has to be writable for the interactive initialization through web browser to take place. At least two operations take place there that need RW :
> 1/ renaming of both install.php and install_req.php.
> 2/ saving into a file the url and credentials for connexion to the database.

Credentials have to be handled out-of-band anyway (keep in mind that
/gnu/store is world-readable so in general we cannot have password in
transit via the store).

> There is no _need_ to copy every time. I did like this in my first patchs because it was _correct_ (I didn't think about efficiency then).
>
> That's why I am proposing the solution which copy only for the very fist activation and for the first activation after a package upgrade (or downgrade).
>
> I don't see how we could avoid this. I don't think it's a good idea to try to avoid the interactive installation as it gives informations and options on the installation to the user.

OK.

> Why "computed-file"?

Take it with a grain of salt because I still have an incomplete
understanding of the initialization process of PMB.

My thought was that, if there’s a “computation” (copying files around,
renaming some) that can be done once and for all, then we could do that
in ‘computed-file’.  But what you’re saying, IIUC, is that this is not
done “once and for all”.

HTH,
Ludo’.